package
{
	import flash.display.Sprite; 
	import flash.events.*;
	
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.render.BasicRenderEngine;
	
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.MovieAssetMaterial;  
	
	import org.papervision3d.materials.utils.*;
	import org.papervision3d.objects.primitives.Cube;
	
	public class Main extends Sprite
	{
		private var viewport: Viewport3D;
		private var scene: Scene3D;
		private var camera: Camera3D;
		private var renderer: BasicRenderEngine;
		
		private var cube:Cube;
	
		public function Main():void
		{
			//viewport = new Viewport3D(w, h, scaleToStage, interactive);
			this.viewport = new Viewport3D(400, 400, false, true);
			this.addChild(viewport);
			
			this.scene = new Scene3D();
			this.camera = new Camera3D();
			this.renderer = new BasicRenderEngine();
			
			var wireframeMaterial:WireframeMaterial = new WireframeMaterial(0x333333);
			wireframeMaterial.doubleSided = true;
			
			var movieAssetMaterial:MovieAssetMaterial = new MovieAssetMaterial("Pic", true);
			movieAssetMaterial.doubleSided = true;
			
			var materialsList:MaterialsList = new MaterialsList();
			materialsList.addMaterial( wireframeMaterial, "front" );
			materialsList.addMaterial( wireframeMaterial, "back" );
			materialsList.addMaterial( movieAssetMaterial, "left" );
			materialsList.addMaterial( movieAssetMaterial, "right" );
			materialsList.addMaterial( wireframeMaterial, "top" );
			materialsList.addMaterial( wireframeMaterial, "bottom" );
			
			this.cube = new Cube(materialsList, 600, 600, 600, 3, 3, 3); 
			this.scene.addChild(cube);
		
			this.addEventListener(Event.ENTER_FRAME, this.onEnterFrame);
		}
		
		private function onEnterFrame(e:Event):void
		{
			this.cube.rotationX -= 2;
			this.cube.rotationY -= 2;
			this.cube.rotationZ -= 2;
			
			this.renderer.renderScene(scene, camera, viewport);
		}
	
	}

}